package org.somda.asciidoc.ieee.word

import org.docx4j.TraversalUtil
import org.docx4j.finders.RangeFinder
import org.docx4j.jaxb.Context
import org.docx4j.openpackaging.packages.WordprocessingMLPackage
import org.docx4j.wml.CTBookmark
import org.docx4j.wml.HpsMeasure
import org.docx4j.wml.Jc
import org.docx4j.wml.JcEnumeration
import org.docx4j.wml.P
import org.docx4j.wml.PPr
import org.docx4j.wml.PPrBase
import org.docx4j.wml.RPr
import org.docx4j.wml.Style
import org.somda.asciidoc.ieee.word.hook.BookmarkHook
import org.somda.asciidoc.ieee.word.hook.DocumentHook
import org.somda.asciidoc.ieee.word.hook.GlobalHook
import org.somda.asciidoc.ieee.word.mapping.createBoolean
import org.somda.asciidoc.ieee.word.mapping.deepCopy
import java.io.ByteArrayInputStream
import java.io.InputStream
import java.io.OutputStream
import java.math.BigInteger

/**
 * Configuration parametrization for the IEEE Word template.
 *
 * @property deactivateNumbering To be used when dealing with amendments/corrigenda. Set to true to remove
 *                               automatically generated numbers from headings figures and tables.
 */
data class WordConfig(
    val deactivateNumbering: Boolean = false
)

/**
 * Setup of a Word template for IEEE standards.
 *
 * - Provides a transform function to traverse the document and seek bookmarks for which the caller can define hooks.
 * - Appends custom IEEE styles to the given Word template.
 */
class WordTemplate(wordStream: InputStream, wordConfig: WordConfig = WordConfig()) {
    val wordPackage: WordprocessingMLPackage = loadWordTemplate(wordStream.readBytes()).also {
        if (wordConfig.deactivateNumbering) {
            deactivateNumbering(it)
        }
    }

    /**
     * Transforms the template by applying hooks and writing the result to an output stream.
     *
     * @param target output stream to write the result to.
     * @param bookmarkHooks bookmark hooks to call back.
     * @param documentHooks document hooks to call back.
     * @param globalHooks global hooks to call back.
     */
    fun transform(
        target: OutputStream,
        bookmarkHooks: Collection<BookmarkHook> = listOf(),
        documentHooks: List<DocumentHook> = listOf(),
        globalHooks: List<GlobalHook> = listOf()
    ) {
        val bookmarks = mutableListOf<CTBookmark>()

        addMissingCaptionStyle(wordPackage)
        addRequirementStyle(wordPackage)
        addTableListStyles(wordPackage)

        documentHooks.forEach {
            it.callback(wordPackage.mainDocumentPart, wordPackage.documentModel)
        }

        for (p in wordPackage.mainDocumentPart.content) {
            if (p !is P) {
                continue
            }
            val rt = RangeFinder("CTBookmark", "CTMarkupRange")
            TraversalUtil(p, rt)
            bookmarks.addAll(rt.starts)
        }

        globalHooks.forEach {
            it.callbackBeforeBookmarkHooks(wordPackage, bookmarks)
        }

        bookmarkHooks.associateBy { it.label().label }.let { bookmarkHookMap ->
            bookmarks.forEach {
                bookmarkHookMap[it.name]?.callback(it)
            }
        }

        globalHooks.forEach {
            it.callbackAfterBookmarkHooks(wordPackage, bookmarks)
        }

        wordPackage.save(target)
    }

    private fun loadWordTemplate(byteArray: ByteArray) =
        WordprocessingMLPackage.load(ByteArrayInputStream(byteArray))

    /*
        To be used when dealing with amendments/corrigenda. Removes automatically generated numbers from
        headings figures and tables.
     */
    private fun deactivateNumbering(wordProcessor: WordprocessingMLPackage) {
        val isNumbered: (String) -> Boolean = { styleVal ->
            when {
                styleVal.startsWith(WordGlobals.STYLE_TEMPLATE_HEADING_LEVEL_PREFIX) -> true
                styleVal.startsWith(WordGlobals.STYLE_TEMPLATE_ANNEX_HEADING_LEVEL_PREFIX) -> true
                styleVal == WordGlobals.STYLE_REGULAR_TABLE_CAPTION -> true
                styleVal == WordGlobals.STYLE_REGULAR_FIGURE_CAPTION -> true
                else -> false
            }
        }
        for (entry in wordProcessor.mainDocumentPart.numberingDefinitionsPart.abstractListDefinitions.entries) {
            for (listLevel in entry.value.listLevels.values) {
                val pStyleVal = listLevel.jaxbAbstractLvl?.pStyle?.`val` ?: continue
                if (isNumbered(pStyleVal)) {
                    listLevel.jaxbAbstractLvl.pStyle = null
                }
            }
        }

        for (style in wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style) {
            if (isNumbered(style.styleId)) {
                style.pPr?.numPr = null
            }
        }
    }

    /*
        Adds an IEEE custom style for annex captions that is typically generated by the IEEE word template macro
        during generation of the first annex caption. However, as the macro is not run by this converter, the
        style needs to be added manually. Otherwise, the annex captions appear in an ugly format.
     */
    private fun addMissingCaptionStyle(wordProcessor: WordprocessingMLPackage) {
        val factory = Context.getWmlObjectFactory()
        val annexCaptionStyle: Style = factory.createStyle()
        annexCaptionStyle.type = "paragraph"
        annexCaptionStyle.styleId = WordGlobals.STYLE_CAPTION
        val n: Style.Name = factory.createStyleName()
        n.`val` = WordGlobals.STYLE_CAPTION.lowercase()
        annexCaptionStyle.name = n

        val pPr = factory.createPPr()
        pPr.keepLines = createBoolean()
        pPr.suppressAutoHyphens = createBoolean()
        pPr.jc = factory.createJc()
        pPr.jc.`val` = JcEnumeration.CENTER
        pPr.spacing = factory.createPPrBaseSpacing()
        pPr.spacing.before = BigInteger.valueOf(120L)
        pPr.spacing.after = BigInteger.valueOf(120L)
        annexCaptionStyle.pPr = pPr

        val rPr = factory.createRPr()
        rPr.rFonts = factory.createRFonts()
        rPr.rFonts.ascii = "Arial"
        rPr.rFonts.hAnsi = "Arial"
        rPr.b = createBoolean()
        rPr.lang = factory.createCTLanguage()
        rPr.lang.`val` = "en-US"
        rPr.lang.eastAsia = "ja-JP"
        annexCaptionStyle.rPr = rPr

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(annexCaptionStyle)
    }

    /*
        Adds a custom style for requirement numbers; this avoids copying the bold-style when updating references to
        requirements.
     */
    private fun addRequirementStyle(wordProcessor: WordprocessingMLPackage) {
        //
        // Requirements paragraph style
        //

        val requirementParagraphStyle = Style().apply {
            type = "paragraph"
            isCustomStyle = true
            styleId = WordGlobals.STYLE_REQUIREMENT
            basedOn = Style.BasedOn()
            basedOn.`val` = WordGlobals.STYLE_PARAGRAPH
            name = Style.Name().apply { `val` = WordGlobals.STYLE_REQUIREMENT }
            pPr = PPr().apply {
                jc = Jc().apply { `val` = JcEnumeration.LEFT }
                spacing = PPrBase.Spacing().apply {
                    after = WordGlobals.space(6)
                }
            }
            rPr = RPr().apply { b = createBoolean() }
        }

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(requirementParagraphStyle)

        //
        // Requirements list style
        //

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(
            createRequirementListStyle(
                WordGlobals.STYLE_REQUIREMENT_UNORDERED_LIST,
                WordGlobals.STYLE_UNORDERED_LIST
            )
        )

        for (i in 1..5) {
            wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(
                createRequirementListStyle(
                    WordGlobals.STYLE_TEMPLATE_REQUIREMENT_NUMBERED_LIST_LEVEL.format(i),
                    WordGlobals.STYLE_TEMPLATE_NUMBERED_LIST_LEVEL.format(i)
                )
            )
        }

        addAbstractNumberingFor(
            wordProcessor,
            WordGlobals.STYLE_TEMPLATE_REQUIREMENT_NUMBERED_LIST_LEVEL.format(""),
            WordGlobals.STYLE_TEMPLATE_NUMBERED_LIST_LEVEL.format("")
        )
    }

    private fun addTableListStyles(wordProcessor: WordprocessingMLPackage) {
        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(
            createTableListStyle(
                WordGlobals.STYLE_TABLE_UNORDERED_LIST,
                WordGlobals.STYLE_UNORDERED_LIST
            )
        )

        for (i in 1..5) {
            wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(
                createTableListStyle(
                    WordGlobals.STYLE_TEMPLATE_TABLE_NUMBERED_LIST_LEVEL.format(i),
                    WordGlobals.STYLE_TEMPLATE_NUMBERED_LIST_LEVEL.format(i)
                )
            )
        }

        addAbstractNumberingFor(
            wordProcessor,
            WordGlobals.STYLE_TEMPLATE_TABLE_NUMBERED_LIST_LEVEL.format(""),
            WordGlobals.STYLE_TEMPLATE_NUMBERED_LIST_LEVEL.format("")
        )
    }

    private fun addAbstractNumberingFor(wordProcessor: WordprocessingMLPackage, style: String, basedOnStyle: String) {
        wordProcessor.mainDocumentPart.numberingDefinitionsPart.abstractListDefinitions.entries.firstOrNull { listDef ->
            listDef.value.listLevels.any { listLevel ->
                listLevel.value.jaxbAbstractLvl.pStyle?.`val`?.startsWith(basedOnStyle) ?: false
            }
        }?.also { listDef ->
            listDef.value.abstractNumNode.deepCopy().also { jaxbListDef ->
                jaxbListDef.lvl.filter { it.pStyle != null }.forEach { level ->
                    level.pStyle.`val` = level.pStyle.`val`.replace(
                        basedOnStyle,
                        style
                    )
                }
                wordProcessor.mainDocumentPart.numberingDefinitionsPart.addAbstractListNumberingDefinition(jaxbListDef)
            }
        }
    }

    private fun createRequirementListStyle(style: String, basedOnStyle: String) = Style().apply {
        styleId = style
        type = "paragraph"
        isCustomStyle = true
        basedOn = Style.BasedOn().apply { `val` = basedOnStyle }
        name = Style.Name().apply { `val` = style }

        pPr = PPr().apply {
            jc = Jc().apply { `val` = JcEnumeration.LEFT }
        }

        rPr = RPr().apply {
            b = createBoolean()
        }
    }

    private fun createTableListStyle(style: String, basedOnStyle: String) = Style().apply {
        styleId = style
        type = "paragraph"
        isCustomStyle = true
        basedOn = Style.BasedOn().apply { `val` = basedOnStyle }
        name = Style.Name().apply { `val` = style }

        pPr = PPr().apply {
            jc = Jc().apply { `val` = JcEnumeration.LEFT }
            spacing = PPrBase.Spacing().apply {
                WordGlobals.space(WordGlobals.PARAGRAPH_SPACE_NONE).also {
                    before = it
                    after = it
                }
            }
        }

        rPr = RPr().apply {
            sz = HpsMeasure().apply { `val` = WordGlobals.fontSize(9.0) }
        }
    }
}